/**
 * @internal
 */
export declare const DEFAULT_VERTEX_SHADER = "\nprecision highp float;\nvoid main() {\n    gl_Position = projectionMatrix * modelViewMatrix * vec4(position, 1.0);\n}\n";
export type ShaderPreset = "uvGradient" | "rainbow" | "glitch" | "rgbGlitch" | "rgbShift" | "shine" | "blink" | "spring" | "duotone" | "tritone" | "hueShift" | "sinewave" | "pixelate" | "halftone" | "slitScanTransition" | "warpTransition" | "pixelateTransition" | "focusTransition";
/**
 * Shader code for presets.
 * Shaders in `shader` can be looked up with keys in `ShaderPreset`.
 *
 * ```ts
 * const shader = shaders["glitch"];
 * console.log(shader);
 * ```
 */
export declare const shaders: Record<ShaderPreset, string>;
